<?php
/**
Plugin Name: 关注公众号可见插件
Plugin URI: https://www.laobuluo.com/4508.html
Description: 通过关注微信公众号，获取验证码从而获得隐藏文本的访问权限。公众号：站长事儿。
Version: 2.1
Author: 老部落团队
Author URI: https://www.laobuluo.com/
 */
define('CNWPER_WEIXIN_VERSION', 2.1);
define('CNWPER_WEIXIN_BASE_FOLDER', plugin_basename(dirname(__FILE__)));
define('CNWPER_WEIXIN_TPL_FILE', 'wxApi.tpl');
define('CNWPER_WEIXIN_COOKIE_NAME', 'cnwper_weixin_secret_code');

register_activation_hook(__FILE__, 'cnwper_weixin_set_options');
function cnwper_weixin_set_options() {
    $options = array(
        'version'         => CNWPER_WEIXIN_VERSION,
        'switch'          => False,
        'mp_qr'           => "",
        'token'           => "",
        'cache_path'      => "",
        'cache_filename'  => "cnwper_wx_caches.data",
        'api_filename'    => "wxApi",
        'cache_expire'    => 2,  // 单位 分钟
        'replay_keyword'  => "验证码",
        'replay_template' => "您的验证码为：【%s】，验证码有效期为[%s]分钟，请抓紧使用，过期需重新申请",
        'cache_storage'   => '',  // 默认为file，先保留选项，后期扩展。也可以考虑SESSION
    );
    $cnwper_weixin_options = get_option('cnwper_weixin_options');
    if(!$cnwper_weixin_options){
        add_option('cnwper_weixin_options', $options, '', 'yes');
    };
}


add_filter('plugin_action_links', 'cnwper_weixin_plugin_action_links', 10, 2);
function cnwper_weixin_plugin_action_links($links, $file) {
    if ($file == plugin_basename(__FILE__)) {
        $links[] = '<a href="admin.php?page=' . CNWPER_WEIXIN_BASE_FOLDER . '/index.php">设置</a>';
    }
    return $links;
}


add_action('admin_menu', 'cnwper_weixin_admin_menu');
function cnwper_weixin_admin_menu() {
    add_options_page('公众号可见插件设置', '公众号可见插件设置', 'manage_options', __FILE__, 'cnwper_weixin_setting_page');
}

function cnwper_weixin_api_generate($cnwper_weixin_options) {
    if ($cnwper_weixin_options['switch']) {
//        if ($cnwper_weixin_options['token']) {
//            // 对参数进行各种判断，如果有缺漏或者不符合要求的返回失败
//        }
        $tpl_content = file_get_contents(plugin_dir_path(__FILE__) . CNWPER_WEIXIN_TPL_FILE);
        $search = array(
            '{{ CNWPER_WEIXIN_TPL_TOKEN }}',
            '{{ CNWPER_WEIXIN_TPL_CAPTCHA_CACHE_PATH }}',
            '{{ CNWPER_WEIXIN_TPL_CAPTCHA_CACHE_FILENAME }}',
            '{{ CNWPER_WEIXIN_TPL_CAPTCHA_CACHE_EXPIRE }}',
            '{{ CNWPER_WEIXIN_TPL_WEIXIN_REPLY_KEYWORD }}',
            '{{ CNWPER_WEIXIN_TPL_WEIXIN_REPLY_TEMPLATE }}',
            '{{ CNWPER_WEIXIN_TPL_HOME_URL }}',
            '{{ CNWPER_WEIXIN_TPL_COOKIE_NAME }}'
        );
        $replace = array(
            $cnwper_weixin_options['token'],
            'dirname(__FILE__)',
            $cnwper_weixin_options['cache_filename'],
            $cnwper_weixin_options['cache_expire'],
            $cnwper_weixin_options['replay_keyword'],
            $cnwper_weixin_options['replay_template'],
            home_url(),
            CNWPER_WEIXIN_COOKIE_NAME
        );
        // 用正则去替换模板源文件中的变量符号{$varname}, 改用 简单的 str替换 就能满足需求
        $res = str_replace($search, $replace, $tpl_content);
        //编译后文件写入某个目录
        file_put_contents(
            join(DIRECTORY_SEPARATOR, [$_SERVER['DOCUMENT_ROOT'], $cnwper_weixin_options['api_filename'].'.php']),
            $res
        );
    } else {
        @unlink(join(DIRECTORY_SEPARATOR, [$_SERVER['DOCUMENT_ROOT'], $cnwper_weixin_options['api_filename'].'.php']));
    }
}

function cnwper_weixin_setting_page() {
    if (!current_user_can('manage_options')) {
        wp_die('Insufficient privileges!');
    }
    $cnwper_weixin_options = get_option('cnwper_weixin_options');
    if($cnwper_weixin_options && isset($_GET['_wpnonce']) && wp_verify_nonce($_GET['_wpnonce']) && !empty($_POST)) {
        $cnwper_weixin_options['switch'] = isset($_POST['switch']);
        $not_modify_param = ['version', 'switch', 'cache_path', 'cache_filename', 'cache_storage'];
        foreach ($cnwper_weixin_options as $k => $v) {
            if ( !in_array( $k, $not_modify_param ) ) {
                $cnwper_weixin_options[$k] = isset($_POST[$k]) ? sanitize_text_field(trim(stripslashes($_POST[$k]))) : '';
            }
        }
        update_option('cnwper_weixin_options', $cnwper_weixin_options);

        if (strlen($cnwper_weixin_options['token']) < 3 && $cnwper_weixin_options['switch']) {
            ?>
            <div class="notice notice-faild settings-error is-dismissible"><p><strong>设置无效，Token不能小于3个字符。</strong></p></div>
            <?php
        } else {
            cnwper_weixin_api_generate($cnwper_weixin_options);
            ?>
            <div class="notice notice-success settings-error is-dismissible"><p>保存完毕</p></div>
            <?php
        }
    }
    ?>

    <link rel='stylesheet'  href='<?php echo plugin_dir_url(__FILE__); ?>layui/css/layui.css' />
<link rel='stylesheet'  href='<?php echo plugin_dir_url(__FILE__); ?>layui/css/laobuluo.css'/>
<script src='<?php echo plugin_dir_url(__FILE__); ?>layui/layui.js'></script>
<style type="text/css">
.wpweixinform .layui-form-label{width:120px;}
.wpweixinform .layui-input{width: 350px;}
.wpweixinform .layui-form-mid{margin-left:3.5%;}
.wpweixinform .layui-form-mid p{padding: 3px 0;}
.laobuluo-wp-hidden {position: relative;}
.laobuluo-wp-hidden .laobuluo-wp-eyes{padding: 5px;position:absolute;top:3px;z-index: 999;display: none;}
.laobuluo-wp-hidden i{font-size:20px;}
.laobuluo-wp-hidden i.dashicons-visibility{color:#009688 ;}
</style>
<div class="container-laobuluo-main">
    <div class="laobuluo-wbs-header" style="margin-bottom: 15px;">
        <div class="laobuluo-wbs-logo">
            <a>
                <img src="<?php echo plugin_dir_url(__FILE__); ?>layui/images/logo.png">
            </a><span class="wbs-span">关注公众号可见插件</span><span class="wbs-free">Free V2.1</span>
        </div>
        <div class="laobuluo-wbs-btn">
            <a class="layui-btn layui-btn-primary" href="https://www.laobuluo.com/?utm_source=wpweixin-setting&utm_media=link&utm_campaign=header" target="_blank">
                <i class="layui-icon layui-icon-home"></i> 插件主页
            </a>
            <a class="layui-btn layui-btn-primary" href="https://www.laobuluo.com/4508.html?utm_source=wpweixin-setting&utm_media=link&utm_campaign=header" target="_blank">
                <i class="layui-icon layui-icon-release"></i> 插件教程
            </a>
        </div>
    </div>
</div>
<!-- 内容 -->
<div class="container-laobuluo-main">
    <div class="layui-container container-m">
        <div class="layui-row layui-col-space15">
            <!-- 左边 -->
            <div class="layui-col-md9">
                <div class="laobuluo-panel">
                    <div class="laobuluo-controw">
                        <fieldset class="layui-elem-field layui-field-title site-title">
                            <legend>
                                <a name="get">
                                    设置选项
                                </a>
                            </legend>
                        </fieldset>
                        <form class="layui-form wpweixinform" action="<?php echo wp_nonce_url('./admin.php?page=' . CNWPER_WEIXIN_BASE_FOLDER . '/index.php'); ?>" name="cnwperweixinform" method="post">

                             <div class="layui-form-item">
                                <label class="layui-form-label"> 开启插件</label>
                                <div class="layui-input-inline" style="width:60px;">
                                    <input type="checkbox" title="开启"
                                     name="switch" <?php
                        if ($cnwper_weixin_options['switch']) {
                            echo 'checked="TRUE"';
                        }
                        ?>/>
                                </div>
                                <div class="layui-form-mid layui-word-aux">
                                    开启/关闭插件
                                </div>
                            </div>


                            <div class="layui-form-item">
                                <label class="layui-form-label">开发者TOKEN</label>
                                <div class="layui-input-block">
                                    <input class="layui-input" type="text" name="token" value="<?php
                        echo esc_attr($cnwper_weixin_options['token']);
                        ?>" size="50"/>
                                    <div class="layui-form-mid layui-word-aux">
                                        如果不启动开发者模式随便填写字符
                                    </div>
                                </div>
                            </div>
                            <div class="layui-form-item">
                                <label class="layui-form-label"> 公众号图片URL</label>
                                <div class="layui-input-block">
                                    <input class="layui-input" type="text" name="mp_qr" value="<?php
                        echo esc_attr($cnwper_weixin_options['mp_qr']);
                        ?>" size="50"/>
                                    <div class="layui-form-mid layui-word-aux">
                                        输入准备好的公众号图片URL地址
                                    </div>
                                </div>
                            </div>
                           <div class="layui-form-item">
                                <label class="layui-form-label"> 验证码获取关键字</label>
                                <div class="layui-input-block">
                                    <input class="layui-input" type="text" name="replay_keyword" value="<?php
                        echo esc_attr($cnwper_weixin_options['replay_keyword']);
                        ?>" size="50"/>
                                    <div class="layui-form-mid layui-word-aux">
                                        验证码获取关键词
                                    </div>
                                </div>
                            </div>
                            <div class="layui-form-item">
                                <label class="layui-form-label"> 验证码有效时间</label>
                                <div class="layui-input-block">
                                    <input class="layui-input" type="text" name="cache_expire" value="<?php
                        echo esc_attr($cnwper_weixin_options['cache_expire']);
                        ?>" size="50"/>
                                    <div class="layui-form-mid layui-word-aux">
                                        单位：分钟，示范：2
                                    </div>
                                </div>
                            </div>
                           <div class="layui-form-item">
                                <label class="layui-form-label"> 接口文件文件名</label>
                                <div class="layui-input-block">
                                    <input class="layui-input" type="text" name="api_filename" value="<?php
                        echo esc_attr($cnwper_weixin_options['api_filename']);
                        ?>" size="50"/>
                                    <div class="layui-form-mid layui-word-aux">
                                        设置生成的公众号接口文件文件名，比如 api                                    </div>
                                </div>
                            </div>
                             <div class="layui-form-item">
                                <label class="layui-form-label"> 验证码回复模版</label>
                                <div class="layui-input-block">
                                    <input class="layui-input" type="text" name="replay_template" value="<?php
                        echo esc_attr($cnwper_weixin_options['replay_template']);
                        ?>" size="50"/>
                                    <div class="layui-form-mid layui-word-aux">
                                        以 %s 作为替换符，第一个%s为验证码位置，第二个%s为有效期位置                                   </div>
                                </div>
                            </div>

                     <div class="layui-form-item">
                          <label class="layui-form-label"></label>
                          <div class="layui-input-block"><input type="submit" name="submit" value="保存设置" class=" layui-btn" lay-submit lay-filter="formDemo" /></div>
                     </div>
                    
                    </form>
                 
                    
                   
                </div>
            </div>
        </div>
        <!-- 左边 -->
        <!-- 右边 -->
        <div class="layui-col-md3">
            <div id="nav">
                <div class="laobuluo-panel">
                    <div class="laobuluo-panel-title">
                        商家推荐 <span class="layui-badge layui-bg-orange">香港服务器活动</span>
                    </div>
                    <div class="laobuluo-shangjia">
                        <a href="https://www.laobuluo.com/3475.html?utm_source=wpweixin-setting&utm_media=link&utm_campaign=rightsads" target="_blank">
                            <img src="<?php echo plugin_dir_url(__FILE__); ?>layui/images/ucloud.jpg">
                        </a>
                    </div>
                </div>
                <div class="laobuluo-panel">
                    <div class="laobuluo-panel-title">
                        关注公众号
                    </div>
                    <div class="laobuluo-code">
                        <img src="<?php echo plugin_dir_url(__FILE__); ?>layui/images/qrcode.png">
                        <p>
                            微信扫码关注 <span class="layui-badge layui-bg-blue">站长事儿</span> 公众号
                        </p>
                        <p>
                            <span class="layui-badge">优先</span> 获取插件更新 和 更多 <span class="layui-badge layui-bg-green">免费插件</span>
                        </p>
                    </div>
                </div>
            </div>
        </div>
        <!-- 右边 -->
    </div>
</div>
</div>
<!-- 内容 -->
<!-- footer -->
<div class="container-laobuluo-main">
    <div class="layui-container container-m">
        <div class="layui-row layui-col-space15">
            <div class="layui-col-md12">
                <div class="laobuluo-footer-code">
                    <span class="codeshow"></span>
                </div>
                <div class="laobuluo-links">
                    <a href="https://www.laobuluo.com/?utm_source=wpweixin-setting&utm_media=link&utm_campaign=footer"  target="_blank">
                        插件官方
                    </a>
                    <a href="https://www.laobuluo.com/donate/?utm_source=wpweixin-setting&utm_media=link&utm_campaign=footer"  target="_blank">
                        赞助插件
                    </a>
                    <a href="https://www.laobuluo.com/4508.html?utm_source=wpweixin-setting&utm_media=link&utm_campaign=footer"  target="_blank">
                        使用说明
                    </a>
                    <a href="https://www.laobuluo.com/about/?utm_source=wpweixin-setting&utm_media=link&utm_campaign=footer"  target="_blank">
                        关于我们
                    </a>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- footer -->
<script>
layui.use(['form', 'element','jquery'], function() {
var $ =layui.jquery;
var form = layui.form;
function menuFixed(id) {
var obj = document.getElementById(id);
var _getHeight = obj.offsetTop;
var _Width= obj.offsetWidth
window.onscroll = function () {
changePos(id, _getHeight,_Width);
}
}
function changePos(id, height,width) {
var obj = document.getElementById(id);
obj.style.width = width+'px';
var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
var _top = scrollTop-height;
if (_top < 150) {
var o = _top;
obj.style.position = 'relative';
o = o > 0 ? o : 0;
obj.style.top = o +'px';

} else {
obj.style.position = 'fixed';
obj.style.top = 50+'px';

}
}
menuFixed('nav');

var laobueys = $('.laobuluo-wp-hidden')

laobueys.each(function(){

var inpu = $(this).find('.layui-input');
var eyes = $(this).find('.laobuluo-wp-eyes')
var width = inpu.outerWidth(true);
eyes.css('left',width+'px').show();

eyes.click(function(){
if(inpu.attr('type') == "password"){
inpu.attr('type','text')
eyes.html('<i class="dashicons dashicons-visibility"></i>')
}else{
inpu.attr('type','password')
eyes.html('<i class="dashicons dashicons-hidden"></i>')
}
})
})

var  clashid = $(".clashid");
form.on('switch(process_switch)', function(data){
if (data.elem.checked){
clashid.show()
}else{
clashid.hide()
}
});

var selectValue = null;

var rule = $("[name=img_process_style_customize]")

form.on('radio(choice)', function(data){

if(selectValue == data.value && selectValue ){
data.elem.checked = ""
selectValue = null;
}else{
selectValue = data.value;
}

if(selectValue=='1'){
rule.attr('disabled',false)
}else{
rule.attr('disabled', true)
}

})

})
</script>


    

    <?php
}



add_filter('the_content', 'cnwper_weixin_secret');
function cnwper_weixin_secret($content){
    $cnwper_weixin_options = get_option('cnwper_weixin_options');
    if ( !$cnwper_weixin_options['switch'] or current_user_can( 'administrator' ) ){
        return $content;
    }
    if (preg_match_all('#<cnwper_wx>([\s\S]*?)</cnwper_wx>#i', $content, $secret_content))
    {
        $cnwper_weixin_cookie = md5($cnwper_weixin_options['token']. CNWPER_WEIXIN_COOKIE_NAME .'cnwper.com');
        $_cnwper_weixin_cookie = isset( $_COOKIE[CNWPER_WEIXIN_COOKIE_NAME] ) ? $_COOKIE[CNWPER_WEIXIN_COOKIE_NAME] : '';
        if( $_cnwper_weixin_cookie != $cnwper_weixin_cookie ){
            $secret_notice = '
                <link rel="stylesheet" id="pure_css-css"  href="https://cdn.jsdelivr.net/npm/css-mint@2.0.7/build/css-mint.min.css?ver=0.0.1" type="text/css"/>
                <style type="text/css">.cm-grid {width: 85%;}</style>
                <div class="cm-grid cm-card secret_view">
                    <div class="cm-row">
                        <div class="cm-col-md-4">
                            <img src="' . $cnwper_weixin_options['mp_qr'] . '" class="cm-resp-img">
                        </div>
                        <div class="cm-col-md-8">
                            <div class="hide_content_info" style="margin:10px 0">
                                <div class="cm-alert primary">
                                      隐藏内容，扫码公众号查看，发【' . $cnwper_weixin_options['replay_keyword'] . '】获验证码
                                </div>
                                <input type="text" id="captcha_input" placeholder="输入验证码并提交" style="width:75%"> &nbsp;&nbsp;
                                <input id="check_secret_view" class="cm-btn success" type="button" value="提交">
                            </div>
                        </div>
                    </div>
                </div>
                <script type="text/javascript" src="https://cdn.jsdelivr.net/npm/jquery@2.1.0/dist/jquery.min.js?ver=2.1"></script>
                <script>
                    $("#check_secret_view").click(function () {
                        var ajax_data = {
                            captcha: $("#captcha_input").val()
                        };
                        $.post("'.home_url($cnwper_weixin_options['api_filename'].'.php?cnwper=check_captcha').'", ajax_data, function (c) {
                            c = $.trim(c);
                            if (c !== "400") {
                                location.reload();
                            } else {
                                alert("您的验证码错误，请重新申请");
                            }
                        });
                    });
                    </script>';
            $content = str_replace($secret_content[0], $secret_notice, $content);
        }
    }
    return $content;
}


add_action('admin_footer', 'cnwper_weixin_secret_toolbar');
function cnwper_weixin_secret_toolbar() {
    if ( !strpos($_SERVER['SCRIPT_NAME'], 'post.php') && !strpos($_SERVER['SCRIPT_NAME'], 'post-new.php')) {
        return '';
    }
    global $wp_version;
    ?>
    <script type="text/javascript">
        jQuery(document).ready(function($) {
            <?php if ( version_compare( $GLOBALS['wp_version'], '3.3alpha', '>=' ) ) : ?>
            edButtons[edButtons.length] = new edButton(
                // id, display, tagStart, tagEnd, access_key, title
                "cnwper_wx", "插入公众号隐藏标签", "<cnwper_wx>", "</cnwper_wx>", "h", "插入公众号隐藏标签"
            );
            <?php else : ?>
            if(s2v_toolbar = document.getElementById("ed_toolbar")<?php echo ($wp_version == '2.7.1') ? ".lastChild.lastChild" : ""; ?>){
                cnwper_wx_el = edButtons.length;
                edButtons[cnwper_wx_el] = new edButton(
                    // id, display, tagStart, tagEnd, access_key, title
                    "cnwper_wx", "插入公众号隐藏标签", "<cnwper_wx>", "</cnwper_wx>", "h", "插入公众号隐藏标签"
                );
                var cnwper_wx_btn = s2v_toolbar.lastChild;

                while (cnwper_wx_btn.nodeType != 1){
                    cnwper_wx_btn = wechatfansBut.previousSibling;
                }

                cnwper_wx_btn = cnwper_wx_btn.cloneNode(true);
                cnwper_wx_btn.value = "cnwper_wx";
                cnwper_wx_btn.title = "插入微信隐藏标签";
                cnwper_wx_btn.onclick = function () {edInsertTag(edCanvas,parseInt(cnwper_wx_el));}
                s2v_toolbar.appendChild(cnwper_wx_btn);
                cnwper_wx_btn.id = "cnwper_wx";
            }
            <?php endif; ?>
        });
    </script>
    <?php
}
?>